Imports System.Web.Mail
Imports System.Data.SqlClient
Public Class AuctionUser
    Private m_uname, m_fullname, m_email As String
    Private m_phoneno, m_address As String

    Public Property UserName() As String
        Get
            Return m_uname
        End Get
        Set(ByVal Value As String)
            m_uname = Value
        End Set
    End Property

    Public Property FullName() As String
        Get
            Return m_fullname
        End Get
        Set(ByVal Value As String)
            m_fullname = Value
        End Set
    End Property

    Public Property EmailAddress() As String
        Get
            Return m_email
        End Get
        Set(ByVal Value As String)
            m_email = Value
        End Set
    End Property


    Public Property PhoneNo() As String
        Get
            Return m_phoneno
        End Get
        Set(ByVal Value As String)
            m_phoneno = Value
        End Set
    End Property


    Public Property Address() As String
        Get
            Return m_address
        End Get
        Set(ByVal Value As String)
            m_address = Value
        End Set
    End Property

    Public Shared Function Login(ByVal un As String, ByVal pwd As String) As AuctionUser
        Dim con As New SqlConnection(ConnectionString)
        Dim uobj As AuctionUser
        Try
            con.Open()
            Dim cmd As New SqlCommand("select  * from users where  uname = @un and pwd = @pwd", con)
            cmd.Parameters.Add("@un", SqlDbType.VarChar, 10).Value = un
            cmd.Parameters.Add("@pwd", SqlDbType.VarChar, 10).Value = pwd
            Dim dr As SqlDataReader
            dr = cmd.ExecuteReader()
            If dr.Read() Then
                uobj = New AuctionUser()
                uobj.UserName = un
                uobj.FullName = dr.Item("fullname")
                uobj.EmailAddress = dr.Item("email")
                uobj.PhoneNo = dr.Item("phone")
                uobj.Address = dr.Item("address")

            End If
            dr.Close()
        Catch ex As Exception
            HttpContext.Current.Response.AppendToLog(ex.Message)
            Throw ex
        Finally
            con.Close()
        End Try
        Return uobj
    End Function

    Public Shared Function SendUserDetails(ByVal email As String) As Boolean
        Dim con As New SqlConnection(ConnectionString)
        Dim found As Boolean = False
        Try
            con.Open()
            Dim cmd As New SqlCommand("select uname,pwd,fullname from users where email = @email", con)
            cmd.Parameters.Add("@email", SqlDbType.VarChar, 50).Value = email

            Dim dr As SqlDataReader
            dr = cmd.ExecuteReader
            If dr.Read() Then
                'send mail
                SendMail(email, dr.Item("uname"), dr.Item("pwd"), dr.Item("fullname"))
                found = True
            End If
            dr.Close()
        Catch ex As Exception
            Throw ex
        Finally
            con.Close()
        End Try
        Return found
    End Function

    Public Shared Function RegisterUser(ByVal uname As String, ByVal fullname As String, ByVal email As String, ByVal phone As String, ByVal address As String) As String
        Dim con As New SqlConnection(ConnectionString)
        Try
            con.Open()
            Dim cmd As New SqlCommand("select  uname from  users where uname = @uname", con)
            cmd.Parameters.Add("@uname", SqlDbType.VarChar, 10).Value = uname
            Dim st As String
            st = cmd.ExecuteScalar
            If Not st Is Nothing Then
                Return "Username already exists!"
            End If
            st = GetPassword()
            cmd.CommandText = "insert into users (uname,pwd,fullname,email,phone,address)  values(@uname,@pwd,@fullname,@email,@phone,@address)"
            cmd.Parameters.Add("@pwd", SqlDbType.VarChar, 10).Value = st
            cmd.Parameters.Add("@fullname", SqlDbType.VarChar, 30).Value = fullname
            cmd.Parameters.Add("@email", SqlDbType.VarChar, 50).Value = email
            cmd.Parameters.Add("@phone", SqlDbType.VarChar, 20).Value = phone
            cmd.Parameters.Add("@address", SqlDbType.VarChar, 50).Value = address
            cmd.ExecuteNonQuery()
            SendMail(email, uname, st, fullname)
            Return Nothing
        Catch ex As Exception
            Return ex.Message
        Finally
            con.Close()
        End Try
    End Function

    Shared Function GetPassword() As String
        Randomize()
        Dim n As Long
        n = Rnd() * 10000
        Return n.ToString().PadRight(4, "0")
    End Function

    Shared Function SendMail(ByVal email As String, ByVal uname As String, ByVal pwd As String, ByVal fullname As String)
        Dim msg As New MailMessage()
        msg.From = "Webmaster"
        msg.To = email.Substring(0, email.IndexOf("@"))
        msg.Subject = "User Details"
        msg.Body = "Dear " & fullname & " <p> Please use the following details to login.<p> Username:" & uname & " <p>Password: " & pwd & "<p>Webmaster,<br>Auction.com"
        msg.BodyFormat = MailFormat.Html
        SmtpMail.SmtpServer = "localhost"
        SmtpMail.Send(msg)
    End Function

    Function UpdatePersonalDetails(ByVal pwd As String, ByVal fullname As String, ByVal phoneno As String, ByVal address As String) As String
        Dim con As New SqlConnection(ConnectionString)
        con.Open()
        Dim cmd As New SqlCommand("update users set fullname = @fullname, phone = @phoneno, address = @address where  uname = @uname and pwd = @pwd", con)
        cmd.Parameters.Add("@fullname", SqlDbType.VarChar, 50).Value = fullname
        cmd.Parameters.Add("@phoneno", SqlDbType.VarChar, 50).Value = phoneno
        cmd.Parameters.Add("@address", SqlDbType.VarChar, 50).Value = address
        cmd.Parameters.Add("@uname", SqlDbType.VarChar, 10).Value = UserName  ' property
        cmd.Parameters.Add("@pwd", SqlDbType.VarChar, 50).Value = pwd

        Try
            If cmd.ExecuteNonQuery() = 1 Then
                ' update user object
                Me.FullName = fullname
                Me.PhoneNo = phoneno
                Me.Address = address
                Return Nothing
            Else
                Return "Sorry! Invalid Password."
            End If
        Catch ex As Exception
            Return ex.Message
        Finally
            con.Close()
        End Try
    End Function


    Function UpdatePassword(ByVal pwd As String, ByVal newpwd As String) As String
        Dim con As New SqlConnection(ConnectionString)
        con.Open()
        Dim cmd As New SqlCommand("update users set pwd = @newpwd where  uname = @uname and pwd = @pwd", con)
        cmd.Parameters.Add("@newpwd", SqlDbType.VarChar, 50).Value = newpwd
        cmd.Parameters.Add("@uname", SqlDbType.VarChar, 10).Value = UserName  ' property
        cmd.Parameters.Add("@pwd", SqlDbType.VarChar, 50).Value = pwd

        Try
            If cmd.ExecuteNonQuery() = 1 Then
                Return Nothing
            Else
                Return "Sorry! Invalid Password."
            End If
        Catch ex As Exception
            Return ex.Message
        Finally
            con.Close()
        End Try
    End Function

    Shared ReadOnly Property ConnectionString() As String
        Get
            Return HttpContext.Current.Application("cs")
        End Get
    End Property

End Class
